package hydro;

import java.io.FileInputStream;
import java.io.File;
import org.w3c.dom.*;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException; 
import java.util.*;

/**
 * Last Revision Sep.3 2008
 * Title: MODReadXML.java
 * Description: Read in XML data into a ArrayList. 
 * Copyright: Copyright (c) 2008-2009
 * Company: CIMAS/UM & AOML/NOAA
 * @author Chao Chen
 * @version 1.1
 */


public class MODReadXML{
	public ArrayList readXML(String filename){
		ArrayList list= new ArrayList(); 
		  try {
	            DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
	            DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
	            //String guipath=System.getProperty("SQLWODGUI_DIR");
	           
	            //Document doc = docBuilder.parse (new File(guipath+File.separator+"flagdefinitions.xml"));
	            Document doc = docBuilder.parse (new File(filename));
	            // normalize text representation
	            doc.getDocumentElement ().normalize ();

	            NodeList listOfItems = doc.getElementsByTagName("item");
	            int totalItems = listOfItems.getLength();	           

	            for(int s=0; s<listOfItems.getLength() ; s++){            	
	                Node firstNode = listOfItems.item(s);
	                if(firstNode.getNodeType() == Node.ELEMENT_NODE){
                        
	                	Element firstElement = (Element)firstNode;

	                    NodeList TypeList = firstElement.getElementsByTagName("type");
	                    Element TypeElement = (Element)TypeList.item(0);

	                    NodeList textFNList = TypeElement.getChildNodes();
	                    String type=((Node)textFNList.item(0)).getNodeValue().trim();
	                    //list.add(((Node)textFNList.item(0)).getNodeValue().trim());
	                    NodeList nameList = firstElement.getElementsByTagName("name");                   
	                          
	                    Element itemElement = (Element)nameList.item(0);
	                    NodeList textLNList = itemElement.getChildNodes();
	                                   
	                    String varname=((Node)textLNList.item(0)).getNodeValue().trim();
	                    list.add(new XMLVariable(type,varname));
	                    	//list.add(((Node)textLNList.item(0)).getNodeValue().trim());
	                }//end of if clause
	            }//end of for loop with s var
	        }catch (SAXParseException err) {
	        System.out.println ("** Parsing error" + ", line " 
	             + err.getLineNumber () + ", uri " + err.getSystemId ());
	        System.out.println(" " + err.getMessage ());
	        }catch (SAXException e) {
	        Exception x = e.getException ();
	        ((x == null) ? e : x).printStackTrace ();
	        }catch (Throwable t) {
	        t.printStackTrace ();
	        }
		return list;
	}
	
	public static void main(String args[]){
		MODReadXML mrx=new MODReadXML();
		ArrayList al=mrx.readXML("variables.xml");
		for(int i=0;i<al.size();i++){
			XMLVariable elements=(XMLVariable)al.get(i);
			System.out.println(elements.getType()+" "+elements.getName());
		}
	}
	
}